xfstests: resolve symlinked devices to real paths
[xfstests-dev.git] / 021
1 #! /bin/bash
2 # FS QA Test No. 021
3 #
4 # xfs_db type attr test (pv 797508 linux-xfs & IRIX)
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2000-2002 Silicon Graphics, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #
22 #-----------------------------------------------------------------------
23 #
24 # creator
25 owner=dxm@sgi.com
26
27 seq=`basename $0`
28 echo "QA output created by $seq"
29
30 here=`pwd`
31 tmp=/tmp/$$
32 status=0        # success is the default!
33 # get standard environment, filters and checks
34 . ./common.rc
35 . ./common.filter
36 . ./common.attr
37
38 _cleanup()
39 {
40         echo "*** unmount"
41         umount $SCRATCH_MNT 2>/dev/null
42         rm -f $tmp.*
43 }
44 trap "_cleanup; exit \$status" 0 1 2 3 15
45
46 _attr()
47 {
48         ${ATTR_PROG} $* 2>$tmp.err >$tmp.out
49         exit=$?
50         sed \
51             -e "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g" \
52             -e "s#$tmp[^ :]*#<TMPFILE>#g;" \
53                 $tmp.out
54         sed \
55             -e "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g" \
56             -e "s#$tmp[^ :]*#<TMPFILE>#g;" \
57                 $tmp.err 1>&2
58         return $exit
59 }
60
61 _getfattr()
62 {
63         ${GETFATTR_PROG} $* 2>$tmp.err >$tmp.out
64         exit=$?
65         sed \
66             -e "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g" \
67             -e "s#$tmp[^ :]*#<TMPFILE>#g;" \
68                 $tmp.out
69         sed \
70             -e "s#$SCRATCH_MNT[^ .:]*#<TESTFILE>#g" \
71             -e "s#$tmp[^ :]*#<TMPFILE>#g;" \
72                 $tmp.err 1>&2
73         return $exit
74 }
75
76 # real QA test starts here
77 _supported_fs xfs
78 _supported_os Linux
79
80 _require_scratch
81 _require_attrs
82
83 rm -f $seq.full
84 umount $SCRATCH_DEV >/dev/null 2>&1
85
86 echo "*** mkfs"
87 _scratch_mkfs_xfs >/dev/null \
88         || _fail "mkfs failed"
89
90 echo "*** mount FS"
91 _scratch_mount >/dev/null \
92         || _fail "mount failed"
93
94 testfile=$SCRATCH_MNT/testfile
95 echo "*** make test file 1"
96
97 touch $testfile.1
98 echo "v1" | _attr -s "a1" $testfile.1 >/dev/null
99 echo "v2--" | _attr -s "a2--" $testfile.1 >/dev/null
100 _getfattr --absolute-names $testfile.1
101 inum_1=`ls -li $testfile.1 | $AWK_PROG '{ print $1 }'`
102
103 echo "*** make test file 2"
104
105 touch $testfile.2
106 echo "value_1" | _attr -s "a1" $testfile.2 >/dev/null
107 echo "value_2" | _attr -s "a2-----" $testfile.2 >/dev/null
108 ( echo start; POSIXLY_CORRECT=yes dd if=/dev/zero bs=65525 count=1; echo end )\
109         | _attr -s "a3" $testfile.2 >/dev/null
110 _getfattr --absolute-names $testfile.2
111
112 # print name and size from 1st line of output
113 _attr -g "a3" $testfile.2 > $tmp.hahahahaplonk
114 head -1 $tmp.hahahahaplonk
115 # NOTE:
116 # Above goo works around some truly bizzaro sh/sed/head interaction
117 # for some versions of these tools (fails on Redhat 7+, 6.2 worked)
118
119 # print out the rest of the data apart from the header
120 # the size is +1 for an extra \n at the end
121 echo -n "size of attr value = "
122 # wc inserts different amounts of whitespace in front...
123 _attr -g "a3" $testfile.2 | tail -3 | wc -c | sed -e "s/^ *//"
124 echo ""
125
126 inum_2=`ls -li $testfile.2 | $AWK_PROG '{ print $1 }'`
127
128 echo "*** unmount FS"
129 umount $SCRATCH_DEV >>$seq.full 2>&1 \
130         || _fail "umount failed"
131
132 echo "*** dump attributes (1)"
133
134 xfs_db -r -c "inode $inum_1" -c "print a.sfattr" $SCRATCH_DEV | \
135         sed -e '/secure = /d' | sed -e '/parent = /d'
136
137 echo "*** dump attributes (2)"
138
139 xfs_db -r -c "inode $inum_2" -c "a a.bmx[0].startblock" -c print $SCRATCH_DEV \
140         | perl -ne '
141 s/,secure//;
142 s/,parent//;
143 s/^(hdr.firstused =) (\d+)/\1 FIRSTUSED/;
144 s/^(hdr.freemap\[0-2] = \[base,size]).*/\1 [FREEMAP..]/;
145 s/^(entries\[0-2] = \[hashval,nameidx,incomplete,root,local]).*/\1 [ENTRIES..]/;
146         print;'
147
148 echo "*** done"
149 exit